#pragma once
#include "GameTalkAPI.h"
//#include "RoomManager.h"
//#include "MMCRoomActor.h"
#include "MessengerActor.h"
#include "ProfileImageActor.h"
#include "GTCommand.h"

class INotifyCommand : public IGTCommand
{
public:
	INotifyCommand(IGTObject *pGTObject, int nTickCount = 0);
	virtual ~INotifyCommand();
	virtual void Execute(void)
	{
		Prev();
		Doit();
		Post();
	}

	virtual bool CheckTick(void)
	{
		if(--m_nTickCount <= 0)
			return true;
		return false;
	}
	void SetTickCount(int nTickCount)
	{
		m_nTickCount = nTickCount;
	}
	int GetRemainTickCount(void)
	{
		return m_nTickCount;
	}

	virtual void ExecuteAsync();
//	virtual IGTObject *GetGTObject(void) { return NULL; };

protected:
	virtual void Prev(void) { }
	virtual void Doit(void) { }
	virtual void Post(void) { }

private:
	IGTObject *m_pGTObject;
	int m_nTickCount;
};
